import java.awt.*;
import java.util.Date;

class AddData extends GridFrame {

	InputField startAt, numCust, numOrder;
	Button acceptBtn;
	Button cancelBtn;
	Logon parentLogon;
	Server theServer;

	public AddData (Logon p, Server s)
	{
		super ("Add some data");
		parentLogon = p;
		theServer = s;
		initScreen ();
	}

	public void initScreen ()
	{
		Label l_start = new Label ("Start Number:", Label.RIGHT);
		startAt = new InputField (10, InputField.INT);

		Label l_cust = new Label ("Add Customers:", Label.RIGHT);
		numCust = new InputField (10, InputField.INT);

		Label l_ord = new Label ("Add Orders:", Label.RIGHT);
		numOrder = new InputField (20, InputField.INT);

		acceptBtn = new Button ("Accept");
			acceptBtn.setBackground (new Color (143, 200, 162));

		cancelBtn = new Button ("Cancel");
			cancelBtn.setBackground (new Color (143, 0, 0));

		addElement (EAST, l_start, 1, 1, 1, 1);
		addElement (WEST,     startAt,   2, 1, 2, 1);
		addElement (EAST, l_cust, 1, 2, 1, 1);
		addElement (WEST,     numCust,   2, 2, 2, 1);
		addElement (EAST,      l_ord,   1, 3, 1, 1);
		addElement (WEST,     numOrder,   2, 3, 2, 1);
		addElement (SOUTHEAST, acceptBtn,  2, 4, 1, 1);
		addElement (SOUTHEAST, cancelBtn,  3, 4, 0, 1);
		pack ();

		show ();
		numCust.requestFocus ();
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.id == Event.KEY_PRESS && evt.key == '\n')
		{
			evt.id = Event.ACTION_EVENT;
			evt.target = acceptBtn;
			evt.arg = "Accept";
			super.deliverEvent (evt);
			return (true);
		} else if ((evt.id == Event.WINDOW_DESTROY) || (evt.arg == "Cancel"))
		{
			dispose();
			parentLogon.reLogon ();
		} else if (evt.arg == "Accept")
		{
			int nc = numCust.getInt();
			int no = numOrder.getInt();
			int sa = startAt.getInt();
			int x, i;

			for (i = 0; i < nc; i++)
			{
				x = i + sa;
				Customer c = new Customer();
				c.name = "";
				c.address = "generated address";
				c.phone = "8232" + x;
				c.suburb = "ADELAIDE";
				c.ubd = "118A" + x;
				c.comments = "This is a generated customer, number " + i + " of " + nc + " starting at " + sa;
				System.out.println ("Adding customer " + c.comments);
				theServer.newCust(c);
				c = null;
			}

			for (i = 0; i < no; i++)
			{
				x = i + sa;
				Order o = new Order();
				o.orderNum = theServer.newOrderNum();
				o.custID = x;
				o.date = new Date();
				o.details = new Vector ();
					OrderDetail od = new OrderDetail ();
					od.code = "FHW";
					od.description = "Generated Family Hawiian";
					od.qty = 1.0;
					od.price = 15.0;
					o.details.addElement (od);
					OrderDetail od1 = new OrderDetail ();
					od1.code = "COKE";
					od1.description = "Generated 1.25L Coke";
					od1.qty = 1.0;
					od1.price = 3.00;
					o.details.addElement (od1);
				System.out.println ("Adding order " + i + " of " + no + " starting at " + x + " order num = " + o.orderNum);
				theServer.newOrder (o);
				o = null;
			}

			theServer.storeData (true);

		}
		return (super.handleEvent (evt));
	}

}
