import java.awt.*;
import java.util.Date;
import java.util.Vector;

class AskForDates extends Dialog {

	InputField df, dt;
	Button ok, cancel;
	Server theServer;
	Checkbox doSales, doProduct;
	Frame parentFrame;

	AskForDates (Frame p, Server s)
	{
		super (p, "Select Dates for Report", true);
		parentFrame = p;
		theServer = s;
		initscreen ();
		show ();
	}

	String getMonth (int theMonth)
	{
		switch (theMonth + 1)
		{
			case 1: return "Jan";
			case 2: return "Feb";
			case 3: return "Mar";
			case 4: return "Apr";
			case 5: return "May";
			case 6: return "Jun";
			case 7: return "Jul";
			case 8: return "Aug";
			case 9: return "Sep";
			case 10: return "Oct";
			case 11: return "Nov";
			case 12: return "Dec";
		}
		return "Jan";
	}

	void initscreen ()
	{
		Panel p1 = new Panel();
			p1.add (new Label ("Date From:"));
			p1.add (df = new InputField (10, InputField.DATE)); 
			p1.add (new Label ("Date To:"));
			p1.add (dt = new InputField (10, InputField.DATE));
		add ("North", p1);

		Panel pWhat = new Panel ();
			pWhat.setLayout (new GridLayout (3, 1));
			pWhat.add (doSales = new Checkbox ("Report Sales Figures", null, true));
			pWhat.add (doProduct = new Checkbox ("Report Product %", null, false));
			pWhat.add (new Label ("NOTE: Day starts at 9:00am and ends at 9:00am the next day"));
		add ("Center", pWhat);

		Panel p2 = new Panel ();
			p2.add (ok = new Button ("OK"));
			p2.add (cancel = new Button ("Cancel"));
		add ("South", p2);

		add ("East", new Label ("                 "));
		add ("West", new Label ("                 "));
		pack ();

		// default the date fields to today
		Date myDate = new Date();

		if (myDate.getHours() < 9)
		{
			// this is really the previous day !
			myDate = new Date(myDate.getTime() - 86400000);
		}

		//System.out.println (myDate);
		int d = myDate.getDate();
		String mon = getMonth (myDate.getMonth());
		int y = myDate.getYear();

		String today = "" + d + " " + mon + " " + y;
		df.setText (today);
		dt.setText (today);
	}

	public boolean handleEvent (Event evt)
	{
		if ((evt.id == Event.KEY_PRESS && evt.key == 0x1b) ||
			(evt.arg == "Cancel"))
		{
			dispose ();
		} else if ((evt.id == Event.KEY_PRESS && evt.key == '\n') ||
				   (evt.arg == "OK"))
		{
			try {
				Date dateFrom = new Date (df.getText());
				Date dateTo = new Date (dt.getText());

				//long startOfNextDay = dateTo.getTime() + (86400000);
				//dateTo = new Date (startOfNextDay);
				System.out.println ("From " + dateFrom + " to " + dateTo);

				if (doSales.getState())
				{
					theServer.doReport (dateFrom, dateTo);
					new ReportDisplay (parentFrame, "Sales Report", "report");
				}

				if (doProduct.getState())
				{
					theServer.doProdReport (dateFrom, dateTo);
					new ReportDisplay (parentFrame, "Product Report", "prodReport");
				}

			} catch (Exception e)
			{
				System.out.println ("Error: " + e);
				e.printStackTrace ();
			}
		}
		return super.handleEvent (evt);
	}

}

class ImageButton extends Canvas {

	Image theImage;
	MediaTracker m;

	public ImageButton (String filename)
	{
		try {
		m = new MediaTracker (this);
		theImage = Toolkit.getDefaultToolkit().getImage (filename);
		m.addImage (theImage, 0);
		m.waitForID (0);
		} catch (InterruptedException e)
		{
		}
		resize (64, 64);
	}

	public void update (Graphics g)
	{
		paint (g);
	}

	public void paint (Graphics g)
	{
		g.drawImage (theImage, 0, 0, this);
	}

	public boolean mouseDown (Event evt, int x, int y)
	{
		return super.mouseDown (evt, x, y);
	}
}

public class CreateMenu extends Frame {

	Button cancelBtn;
	ImageButton userBtn;
	ImageButton itemBtn;
	ImageButton postCodeBtn;
	ImageButton custBtn;
	ImageButton reportBtn;
	ImageButton backupBtn;
	ImageButton importBtn;
	ImageButton exportBtn;
	ImageButton badCustBtn;
	Logon parentLogon;

	Vector openedWindows;
	Vector windowNames;

	public CreateMenu (Logon parent)
	{
		super ("Maintenance");
		parentLogon = parent;
		openedWindows = new Vector ();
		windowNames = new Vector ();
		initScreen ();
		setBackground (new Color (207,207,182));
	}

	public GridFrame getWindowByName (String name)
	{
		for (int i = 0; i < windowNames.size(); i++)
		{
			String s = (String) windowNames.elementAt (i);
			if (s.equals (name))
			{
				// found it
				return (GridFrame) openedWindows.elementAt (i);
			}
		}
		return null;
	}

	public void addWindow (String name, GridFrame theWindow)
	{
		//System.out.println ("Adding " + name + " " + theWindow);
		windowNames.addElement (name);
		openedWindows.addElement (theWindow);
	}

	public void removeWindow (GridFrame g)
	{
		//System.out.println ("remove window " + g);
		for (int i = 0; i < openedWindows.size(); i++)
		{
			GridFrame gf = (GridFrame) openedWindows.elementAt (i);
			if (gf == g)
			{
				// found it
				windowNames.removeElementAt (i);
				openedWindows.removeElementAt (i);
				return;
			}
		}
	}

	public void closeAllWindows (String s)
	{
		//System.out.println ("Close all like " + s);
		for (int i = 0; i < openedWindows.size(); i++)
		{
			GridFrame g = (GridFrame) openedWindows.elementAt (i);
			String n = (String) windowNames.elementAt (i);
			//System.out.println ("window " + i + " = " + n);
			
			if (g != null)
			{
				if (s == null)
				{
					g.dispose ();
					openedWindows.removeElementAt (i);
					windowNames.removeElementAt (i);
					i = -1;
				}
				else if (s.equals (n))
				{
					g.dispose ();
					openedWindows.removeElementAt (i);
					windowNames.removeElementAt (i);
					i = -1;
				}
				//else System.out.println (s + " != " + n);
			}
		}
	}

	public void initScreen ()
	{
		userBtn = new ImageButton ("userBtn.jpg");
		itemBtn = new ImageButton ("itemBtn.jpg");
		postCodeBtn = new ImageButton ("postcodeBtn.jpg");
		custBtn = new ImageButton ("custBtn.jpg");
		reportBtn = new ImageButton ("reportBtn.gif");
		backupBtn = new ImageButton ("backupBtn.jpg");
		importBtn = new ImageButton ("btnImport.jpg");
		exportBtn = new ImageButton ("btnExport.jpg");
		badCustBtn = new ImageButton ("badCust.gif");

		cancelBtn = new Button ("Close");
			cancelBtn.setBackground (new Color (255,128,128));

		add (userBtn);
		add (itemBtn);
		add (postCodeBtn);
		add (custBtn);
		add (reportBtn);
		add (backupBtn);
		add (importBtn);
		add (exportBtn);
		add (badCustBtn);
		add (cancelBtn);

		resize (200, (70 * 5) + 80);

		userBtn.reshape (10,35,64,64);
		itemBtn.reshape (10,40+64,64,64);
		postCodeBtn.reshape (10,45+128,64,64);
		custBtn.reshape (10,50+64+64+64,64,64);
		reportBtn.reshape (10,55+64+64+65+64,64,64);

		backupBtn.reshape (20+64,35,64,64);
		exportBtn.reshape (20+64,40+64,64,64);
		importBtn.reshape (20+64,45+128,64,64);
		badCustBtn.reshape(20+64,50+128+64,64,64);

		cancelBtn.reshape (10,65+256+64,64,30);

		show ();
	}

	void runCommand (String s)
	{
		try {
			Process p = Runtime.getRuntime().exec (s);
			p.waitFor ();
		} catch (Exception e)
		{
		}
	}

	public boolean mouseDown (Event evt, int x, int y)
	{
		if (evt.target == userBtn)
		{
			openUserTable ();
		} else if (evt.target == itemBtn)
		{
			openItemTable ();
		} else if (evt.target == postCodeBtn)
		{
			openSuburbTable ();
		} else if (evt.target == custBtn)
		{
			openCustTable ();
		} else if (evt.target == reportBtn)
		{
			AskForDates myAFD = new AskForDates (this, parentLogon.theServer);
		} else if (evt.target == backupBtn)
		{
			runCommand ("backmeup");
			new MessageBox (this, "Backup Data", "Data Backup is now complete");
		} else if (evt.target == exportBtn)
		{
			runCommand ("mountflop");
			parentLogon.theServer.exportData();
			runCommand ("umountflop");
			new MessageBox (this, "Export Data", "Data Export is now complete");
		} else if (evt.target == importBtn)
		{
			runCommand ("backmeup");
			runCommand ("mountflop");
			parentLogon.theServer.importData();
			runCommand ("umountflop");
			new MessageBox (this, "Import Data", "Data Import is now complete");
		} else if (evt.target == badCustBtn)
		{
			parentLogon.theServer.badCustReport ();
			new ReportDisplay (this, "Bad Customer Report", "badCust");
		}
		return false;
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.id == Event.KEY_PRESS && evt.key == '\n')
		{
			evt.id = Event.ACTION_EVENT;
			evt.target = cancelBtn;
			evt.arg = "Close";
			super.deliverEvent (evt);
			return (true);
		} else if (evt.id == Event.KEY_PRESS && evt.key == 0x1b)
		{
			closeAllWindows (null);
			dispose ();
			parentLogon.reLogon ();
		} else if (evt.id == Event.KEY_PRESS)
		{
			switch (evt.key)
			{
				case 'u':
				case 'U':
					openUserTable ();
					break;
				case 'i':
				case 'I':
					openItemTable ();
					break;
				case 'p':
				case 'P':
					openSuburbTable ();
					break;
				case 'c':
				case 'C':
					openCustTable ();
					break;
			}
		} else if ((evt.id == Event.WINDOW_DESTROY) ||
			   (evt.arg == "Close"))
		{
			closeAllWindows (null);
			dispose ();
			parentLogon.reLogon ();
		}
		return (super.handleEvent (evt));
	}

	public void openUserTable ()
	{
		GridFrame g = getWindowByName ("UserTable");
		if (g != null)
		{
			g.show ();
		}
		else
		{
			g = (GridFrame) new UserTable (this, parentLogon.theServer);
		}
	}

	public void openItemTable ()
	{
		GridFrame g = getWindowByName ("ItemTable");
		if (g != null)
		{
			g.show ();
		}
		else
		{
			g = (GridFrame) new ItemTable (this, parentLogon.theServer);
		}
	}

	public void openSuburbTable ()
	{
		GridFrame g = getWindowByName ("SuburbTable");
		if (g != null)
		{
			g.show ();
		}
		else
		{
			g = (GridFrame) new SuburbTable (this, parentLogon.theServer);
		}
	}

	public void openCustTable ()
	{
		GridFrame g = getWindowByName ("CustTable");
		if (g != null)
		{
			g.show ();
		}
		else
		{
			g = (GridFrame) new CustTable (this, parentLogon.theServer);
		}
	}
}
