import java.awt.*;
import java.util.Vector;

class GridColumn {

	String title;
	int width;

	public GridColumn (String t, int w)
	{
		title = t;
		width = w;
	}
}

class Grid extends Canvas {

	int displayRows;
	Vector columns;
	Font titleFont, textFont;
	int theWidth;

	public Dimension minumumSize ()
	{
		return new Dimension (20 * (displayRows+1), theWidth);
	}

	public Grid (int r, Vector c)
	{
		displayRows = r;
		columns = c;

		theWidth = 0;

		for (int i = 0; i < c.size(); i++)
		{
			GridColumn x = (GridColumn) c.elementAt (i);
			theWidth += x.width;
		}

		//resize (20 * (displayRows+1), theWidth);

		titleFont = new Font ("dialog", Font.BOLD | Font.ITALIC, 14);
		textFont = new Font ("dialog", Font.PLAIN, 14);
	}

	public void update (Graphics g)
	{
		paint (g);
	}

	public void paint (Graphics g)
	{
		int x, y;

		x = size().width;
		y = size().height;

		g.setColor (Color.white);
		g.fillRect (0, 0, x, y);

		// draw outline box
		g.setColor (Color.black);
		g.drawRect (0, 0, x, y);

		// draw the horizontal grid rows

		int r, i;
		for (i = 0; i < displayRows; i++)
		{
			r = 20 * (i+1);
			
			if (i == 0)
				g.drawLine (0, r-2, y, r-2);

			g.drawLine (0, r, y, r);
		}

		// draw the vertical lines
		r = 0;

		g.setFont (titleFont);
		for (i = 0; i < columns.size(); i++)
		{
			GridColumn col = (GridColumn) columns.elementAt (i);
			g.drawString (col.title, r + 2, 12);

			if (i >= (columns.size()-1))
				break;

			r += col.width;

			g.drawLine (r, 0, r, y);
		}

		g.setFont (textFont);
	}
}
