import java.io.*;
import java.util.Date;
import java.awt.*;
import java.util.Vector;

class DocketDisplayFromOrder extends Dialog {

	Order theOrder;
	TextArea theText;
	LastOrders myLastOrders;
	Server theServer;
	Select theParent;
	Customer myCust;

	public DocketDisplayFromOrder (LastOrders c, Order o, Server s, Customer cm, Select sel)
	{
		super ((Frame) c, "Docket Display", true);
		myLastOrders = c;
		myCust = cm;
		theOrder = o;
		theServer = s;
		theParent = sel;
		initScreen ();
		getText();
		show ();
	}

	public void initScreen ()
	{
		add ("Center", theText = new TextArea (30,45));
		theText.setFont (new Font ("Courier", Font.PLAIN, 12));

		Button b1, b2, b3, b4;

		Panel p = new Panel();
		p.add (b1 = new Button ("Same Again"));
			b1.setBackground (new Color (143, 200, 162));
		p.add (b2 = new Button ("Reprint"));
			b2.setBackground (new Color (145,196,255));
		p.add (b4 = new Button ("Cancel"));
			b4.setBackground (new Color (255,128,128));

		add ("South", p);

		pack ();
	}

	public void getText ()
	{
		try {
			String filename = "dockets/docket" + theOrder.orderNum;
			long filelen = new File(filename).length();
			//System.out.println ("filelen = " + filelen);
			DataInputStream fp = new DataInputStream (new FileInputStream (filename));
			byte Buffer[] = new byte [(int)filelen];
			fp.readFully (Buffer);
			fp.close ();
			theText.setText (new String (Buffer,0));
		}
		catch (IOException e)
		{
			e.printStackTrace ();
		}
	}

	public boolean handleEvent (Event evt)
	{
		if ((evt.arg == "Cancel") || (evt.id == Event.KEY_PRESS && evt.key == 0x1b))
		{
			dispose ();
		}
		else if ((evt.arg == "Reprint") || (evt.id == Event.KEY_PRESS && evt.key == 'r'))
		{
			dispose ();
			theOrder.printDocket (myCust);
		}
		else if ((evt.arg == "Same Again") || (evt.id == Event.KEY_PRESS && evt.key == 's'))
		{
			System.out.println ("Same again");
			myLastOrders.dispose ();
			dispose ();
			myLastOrders.theParent.makeCopy (theOrder.orderNum);
		}

		return super.handleEvent (evt);
	}
}

class LastOrders extends GridFrame {

	Button cancelBtn;
	OrderList orderList;
	Vector custOrders;
	Customer theCust;
	Server theServer;
	OrderEntry theParent;

	public LastOrders (OrderEntry p, Server s, Customer c)
	{
		super ("Last Orders For Customer");

		theParent = p;
		theServer = s;
		theCust = c;
		initScreen ();
	}

	public void initScreen ()
	{
		orderList = new OrderList ();

		// populate the order list
		custOrders = theServer.getOrdersByCust (theCust);

		for (int i = custOrders.size()-1; i >= 0; i--)
		{
			Order myOrder = (Order) custOrders.elementAt (i);
			String s = "" + myOrder.orderNum + " " + InputField.DateString(myOrder.date) + "    $";
			String m = "" + Money.toString (myOrder.totalPrice());
			while (m.length() < 6) m = " " + m;
			orderList.addItem (s + m);
		}

		cancelBtn = new Button ("Cancel");
			cancelBtn.setBackground (new Color (255,128,128));

		gridc.fill = gridc.BOTH;
		gridc.weighty = 1.0;
		addElement (NORTHEAST, orderList,   1, 1, 3, 4);
		gridc.weighty = 0.0;
		gridc.fill = gridc.NONE;
		addElement (SOUTHEAST, cancelBtn,   3, 5, 1, 1);

		pack ();
		show ();
		orderList.requestFocus ();
	}

	public boolean handleEvent (Event evt)
	{
		if ((evt.id == Event.KEY_PRESS && evt.key == 0x1b) || 
					(evt.id == Event.WINDOW_DESTROY) ||
			   		(evt.arg == "Cancel"))
		{
			dispose ();
		} else if (evt.id == Event.LIST_SELECT && custOrders != null)
		{
			int i = custOrders.size() - orderList.getSelectedIndex () - 1;
			Order myOrder = (Order) custOrders.elementAt (i);
			if (myOrder != null)
			{
				new DocketDisplayFromOrder (this, myOrder, theServer, theCust, null);
			}
		}
		return (super.handleEvent (evt));
	}

}

