import java.awt.*;

public class Logon extends GridFrame {

	InputField userCode, passWord;
	Button acceptBtn;
	Server theServer;
	String theStore;

	public static void main (String args[])
	{
		Logon myLogon = new Logon(args[0]);
		myLogon.theServer = new Server ((Frame)myLogon);
	}

	public Logon (String storename)
	{
		super (storename + " Logon Screen");
		theStore = storename;
		initScreen ();
	}

	void reLogon ()
	{
		userCode.setText ("");
		passWord.setText ("");
		show ();
		userCode.requestFocus ();
		theServer.flush ();
	}

	public void initScreen ()
	{
		Label l_userCode = new Label ("User Code:", Label.RIGHT);
		userCode = new InputField (20, InputField.CAPS);

		Label l_passwd = new Label ("Password:", Label.RIGHT);
		passWord = new InputField (20, InputField.PASSWORD);

		acceptBtn = new Button ("Accept");
			acceptBtn.setBackground (new Color (143, 200, 162));

		addElement (EAST, l_userCode, 1, 1, 1, 1);
		addElement (WEST,     userCode,   2, 1, 1, 1);
		addElement (EAST,      l_passwd,   1, 2, 1, 1);
		addElement (WEST,     passWord,   2, 2, 1, 1);
		addElement (SOUTHEAST, acceptBtn,  2, 3, 1, 1);
		pack ();

		show ();
		userCode.requestFocus ();
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.id == Event.KEY_PRESS && evt.key == '\n')
		{
			evt.id = Event.ACTION_EVENT;
			evt.target = acceptBtn;
			evt.arg = "Accept";
			super.deliverEvent (evt);
			return (true);
		} else if (evt.id == Event.WINDOW_DESTROY)
		{
			theServer.flush ();
			System.out.println ("Quit");
			System.exit (0);
		} else if (evt.arg == "Accept")
		{
			String enteredPassword = passWord.getText().trim();
			String enteredUser = userCode.getText().trim();

			if (enteredUser.equals ("ADD") &&
			    enteredPassword.equals ("add3"))
			{
				hide ();
				new AddData (this, theServer);
				userCode.setText ("");
				passWord.setText ("");
				userCode.requestFocus ();
			}
			else if (enteredUser.equals ("FIX CUST") &&
				enteredPassword.equals ("fixme"))
			{
				theServer.check_cust (true);
			}
			else if (enteredUser.equals ("CHECK CUST") &&
				enteredPassword.equals ("check"))
			{
				theServer.check_cust (false);
			}
			else if (enteredUser.equals ("FIX ORDERS") &&
				enteredPassword.equals ("fixme"))
			{
				theServer.check_orders (true);
			}
			else if (enteredUser.equals ("CHECK ORDERS") &&
				enteredPassword.equals ("check"))
			{
				theServer.check_orders (false);
			}
			else if (enteredUser.equals ("MAINT") &&
			    enteredPassword.equals ("dog3"))
			{
				hide ();
				new CreateMenu (this);
				userCode.setText ("");
				passWord.setText ("");
				userCode.requestFocus ();
			}
			else if (enteredUser.equals ("QUIT"))
			{
				theServer.flush ();
				System.out.println ("Quit");
				System.exit (0);
			}
			else if (theServer.validateLogon (enteredUser, enteredPassword))
			{
				hide ();
				Select mySelect = new Select (this, theStore);
				userCode.setText ("");
				passWord.setText ("");
				userCode.requestFocus ();
			}
			else
			{
				userCode.setText ("");
				passWord.setText ("");
				userCode.requestFocus ();
			}
		}
		return (super.handleEvent (evt));
	}

}
