import java.io.*;
import java.awt.*;

class ReportDisplay extends Dialog {

	TextArea theText;
	String filename;

	public ReportDisplay (Frame f, String t, String fn)
	{
		super (f, t, true);
		filename = fn;
		initScreen ();
		getText();
		show ();
	}

	public void initScreen ()
	{
		add ("Center", theText = new TextArea (30,45));
		theText.setFont (new Font ("Courier", Font.PLAIN, 12));

		Button b1, b2;

		Panel p = new Panel();
		p.add (b1 = new Button ("Print"));
			b1.setBackground (new Color (143, 200, 162));
		p.add (b2 = new Button ("Cancel"));
			b2.setBackground (new Color (255,128,128));

		add ("South", p);

		pack ();
	}

	public void getText ()
	{
		try {
			long filelen = new File(filename).length();
			DataInputStream fp = new DataInputStream (new FileInputStream (filename));
			byte Buffer[] = new byte [(int)filelen];
			fp.readFully (Buffer);
			fp.close ();
			theText.setText (new String (Buffer,0));
		}
		catch (IOException e)
		{
			e.printStackTrace ();
		}
	}

	public boolean handleEvent (Event evt)
	{
		if ((evt.arg == "Cancel") || (evt.id == Event.KEY_PRESS && evt.key == 0x1b))
		{
			dispose ();
		}
		else if ((evt.arg == "Print") || (evt.id == Event.KEY_PRESS && evt.key == '\n'))
		{
			try {
				Runtime.getRuntime().exec ("printit " + filename);
			} catch (Exception e)
			{
				e.printStackTrace ();
			}

			dispose ();
		}

		return super.handleEvent (evt);
	}
}
