import java.awt.*;
import java.util.Vector;

class SelectOrderList extends List {

	public SelectOrderList ()
	{
		super (10, false);
	}

	public Dimension preferredSize ()
	{
		return new Dimension (680, 180);
	}
}

public class Select extends GridFrame {

	InputField phone, name, orderNo;
	SelectOrderList orders;
	Button reportBtn, quitBtn, acceptBtn;
	Logon parentLogon;
	int ordersToday;
	float valueToday;
	Label l_ordersToday, l_valueToday;
	Server theServer;
	Vector orderVector;
	Choice howMany;

	public Select (Logon theParent, String theTitle)
	{
		super (theTitle + " Selection Screen");
		parentLogon = theParent;
		theServer = parentLogon.theServer;
		initScreen ();
	}

	public void initScreen ()
	{
		Label l_phone = new Label ("Phone No:", Label.RIGHT);
		phone = new InputField (20, InputField.INT);
		Label l_name = new Label ("Name:", Label.RIGHT);
		name = new InputField (40, InputField.CAPS);
		Label l_order = new Label ("Order No:", Label.RIGHT);
		orderNo = new InputField (20, InputField.INT);
		orders = new SelectOrderList ();
		l_ordersToday = new Label ("");
		l_valueToday = new Label ("");
		Label l1 = new Label ("Orders Today:", Label.RIGHT);
		Label l2 = new Label ("Value Today:", Label.RIGHT);
		Label l_howMany = new Label ("Show How Many:", Label.RIGHT);
		howMany = new Choice ();
			howMany.addItem ("20");
			howMany.addItem ("50");
			howMany.addItem ("100");
			howMany.addItem ("200");
			howMany.addItem ("500");

		reportBtn  = new Button ("Report");
			reportBtn.setBackground (new Color (145,196,255));
		quitBtn  = new Button ("Quit");
			quitBtn.setBackground (new Color (255, 128, 128));
		acceptBtn = new Button ("Accept");
			acceptBtn.setBackground (new Color (143, 200, 162));

		addElement (EAST, l_phone,	1,1,1,1);
		addElement (WEST,     phone,	2,1,4,1);
		addElement (EAST,     l_name,	1,2,1,1);
		addElement (WEST,     name,	2,2,4,1);
		addElement (EAST,     l_order,	1,3,1,1);
		addElement (WEST,     orderNo,	2,3,4,1);
		addElement (WEST, orders, 1,4,5,1);
		addElement (EAST, l1,	1,5,1,1);
		addElement (WEST,     l_ordersToday,	2,5,1,1);
		addElement (EAST,     l2,		1,6,1,1);
		addElement (WEST,     l_valueToday,	2,6,1,1);
		addElement (EAST, l_howMany,	3,5,1,1);
		addElement (WEST,     howMany,	4,5,1,1);

		gridc.fill = GridBagConstraints.HORIZONTAL;
		gridc.ipadx = gridc.ipady = 20;
		addElement (SOUTHEAST, acceptBtn,	3,7,1,1);
		addElement (SOUTHEAST, reportBtn,   4,7,1,1);
		addElement (SOUTHEAST, quitBtn,		5,7,1,1);

		redoLabels ();
		pack ();
		show ();
		phone.requestFocus ();
	}

	public void redoLabels ()
	{
		l_ordersToday.setText("  " + theServer.theStats.ordersToday);
		l_valueToday.setText("$ " + Money.toString(theServer.theStats.valueToday));

		int ii = 20;
		try {
			ii = Integer.parseInt(howMany.getSelectedItem()); 
		} catch (NumberFormatException e)
		{
		}

		orderVector = theServer.getLastOrders (ii);
		orders.clear ();

		for (int i = 0; i < orderVector.size(); i++)
		{
			Order myOrder = (Order) orderVector.elementAt (i);
			String s = "" + myOrder.orderNum + " " + myOrder.date;
			int ind = s.indexOf (":");
			if (ind != -1)
			{
				s = s.substring (0, ind + 3);
			}
			String m = " $" + Money.toString (myOrder.totalPrice());

			if (myOrder.isPickup)
			{
				s = s + " Pickup: " + myOrder.name + " at " + myOrder.time + m;
			}
			else
			{
				Customer myCust = theServer.findCustomerID (myOrder.custID);
				if (myCust != null)
				{
				s = s + " Deliver to: " + myCust.phone + " " + myCust.name + " " + myCust.address + " " + myCust.suburb + " " + myCust.ubd + m;
				}
			}

			orders.addItem (s);
		}
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.target == howMany)
		{
			redoLabels ();
			theServer.bumpTimer();
		}
		else if (evt.id == Event.LIST_SELECT)
		{
			theServer.bumpTimer();
			int ind = orders.getSelectedIndex();
			Order myOrder = (Order) orderVector.elementAt (ind);
			if (myOrder != null)
			{
				orderNo.setInt ((int)myOrder.orderNum);
				phone.setText ("");
				name.setText ("");
				evt.id = Event.ACTION_EVENT;
				evt.target = acceptBtn;
				evt.arg = "Accept";
				super.deliverEvent (evt);
				return (true);
			}
		}
		else if (evt.id == Event.KEY_PRESS && evt.key == '\n')
		{
			theServer.bumpTimer();
			evt.id = Event.ACTION_EVENT;
			evt.target = acceptBtn;
			evt.arg = "Accept";
			super.deliverEvent (evt);
			return (true);
		}
		else if (evt.id == Event.WINDOW_DESTROY ||
		    	 evt.arg == "Quit" ||
				 (evt.id == Event.KEY_PRESS && evt.key == 0x1b))
		{
			dispose ();
			parentLogon.reLogon ();
		} else if (evt.arg == "Report")
		{
			theServer.bumpTimer();
			new AskForDates (this, theServer);
		} else if (evt.arg == "Accept")
		{
			theServer.bumpTimer();
			String ePhone = phone.getText();
			String eName  = name.getText();
			int eOrder = orderNo.getInt();
			Order theOrder = null;

			boolean isPickup = false;
			Vector results = null;
			Customer theCust = null;

			if (ePhone.length() > 0 || eName.length() > 0)
			{
				results = theServer.findCustomers (ePhone, eName);
			} else if (eOrder != 0)
			{
				theOrder = theServer.getOrder ((long) eOrder);
				if (theOrder != null)
				{
					theCust = theServer.findCustomerID (theOrder.custID);
				}
			}
			else // pickup order
			{
				isPickup = true;
			}

			if (!isPickup)
			{
			if (theOrder != null)
			{
				// found an old order
				hide();
				new OrderEntry (this, theCust, theServer, theOrder);

			} else if (results == null || results.size() == 0)
			{
				// new customer
				hide();
				new CustDetails (this, parentLogon.theServer, ePhone, eName);
			} else if (results.size() == 1)
			{
				// found 1 customer
				hide();
				new CustDetails (this, parentLogon.theServer, 
				    (Customer) results.elementAt(0));
			} else if (results.size() > 1)
			{
				// found more than 1 customer
				hide();
				new CustDetailsSelect (this, parentLogon.theServer, results);
			}
			}
			else
			{
				hide ();
				new OrderEntry (this, null, theServer);
			}

			phone.setText ("");
			name.setText ("");
			orderNo.setText ("");
			phone.requestFocus ();
			redoLabels ();
		}
		return (super.handleEvent (evt));
	}

}
