import java.awt.*;

interface suburbTracker {

	public void SuburbHasChanged (Suburb s);
	
	public void ClearMinOrder ();
	
	public void NewSuburb ();
}

class SuburbField extends InputField {

	Server theServer;
	suburbTracker parent;

	public SuburbField (Server s, suburbTracker p)
	{
		super (15, InputField.CAPS);
		theServer = s;
		parent = p;
	}

	public boolean handleEvent(Event e) 
	{
		if (e.id==Event.KEY_PRESS)
		{
			switch (e.key)
			{
				case '\n':
					return false;

				case 127:
					setText ("");
					return false;

				default:
					if ((e.key >= 'a') && (e.key <= 'z'))
						e.key -= 'a' - 'A';
			}
		}
		else if (e.id == Event.GOT_FOCUS)
		{
			parent.ClearMinOrder ();
		}
		else if (e.id == Event.LOST_FOCUS)
		{
			String newText = getText();
			Suburb resolvesTo = theServer.matchSuburb (newText);
			if (resolvesTo == null)
			{
				System.out.println ("we are here");
				parent.NewSuburb ();
			}
		}
		else if (e.id == Event.KEY_RELEASE)
		{
			//super.handleEvent (e);
			System.out.println ("Released key '" + e.key + "'");

			if (e.key != ' ')
			{
				String newText = getText();
				Suburb resolvesTo = theServer.matchSuburb (newText);
				if (resolvesTo != null)
				{
					setText (resolvesTo.suburb);
					select (newText.length(), resolvesTo.suburb.length());
					parent.SuburbHasChanged (resolvesTo);
	//				return true;
				}
			}
		}
		return(super.handleEvent(e));
	}
}
