import java.io.*;
import java.awt.*;

class User extends Object {

	String name, password;

	public User ()
	{
		name = null;
		password = null;
	}

	public User (DataInputStream fp, int Version) throws IOException 
	{
		read (fp, Version);
	}

	public void read (DataInputStream in, int Version) throws IOException
	{
		name = in.readUTF();
		password = in.readUTF();
	}

	public void write (DataOutputStream out) throws IOException
	{
		out.writeUTF(name);
		out.writeUTF(password);
	}

	public void print (PrintStream out) throws IOException
	{
		out.println (name + "\t" + password);
	}

	public void printHeader (PrintStream out) throws IOException
	{
		out.println ("Name\tPassword");
	}

	public void importString (String s) 
	{
		String t = "\t";
		int i;

		i = s.indexOf ("\t");
		name = s.substring (0, i);
		password = s.substring (i+1);
	}
}

class UserEdit extends GridFrame {

	InputField userCode, oldPassword, passWord, passWord2;
	Button acceptBtn;
	Button cancelBtn;
	Server theServer;
	boolean newUser;
	UserTable parentList;
	User oldUser;
	CreateMenu CM;

	public UserEdit (CreateMenu c, Server s, UserTable l)
	{
		super ("New User");
		CM = c;
		CM.addWindow ("UserEdit", (GridFrame) this);
		newUser = true;
		theServer = s;
		initScreen ();
		parentList = l;
		oldUser = null;
	}

	public UserEdit (CreateMenu c, Server s, UserTable l, User ou)
	{
		super ("Modify User Details");
		CM = c;
		CM.addWindow ("UserEdit", (GridFrame) this);
		newUser = false;
		theServer = s;
		oldUser = ou;
		initScreen ();
		parentList = l;
	}

	public void initScreen ()
	{
		Label l_userCode = new Label ("User Code:", Label.RIGHT);
		userCode = new InputField (20, InputField.CAPS);
		if (newUser == false) // modify user details
			userCode.setText (oldUser.name);

		Label l_passwdOld = null;
		if (newUser == false)
		{
			l_passwdOld = new Label ("Old Password:", Label.RIGHT);
			oldPassword = new InputField (20, InputField.PASSWORD);
		}

		Label l_passwd = new Label ("New Password:", Label.RIGHT);
		passWord = new InputField (20, InputField.PASSWORD);

		Label l_passwd2 = new Label ("Confirm Password:", Label.RIGHT);
		passWord2 = new InputField (20, InputField.PASSWORD);

		acceptBtn = new Button ("Accept");
			acceptBtn.setBackground (new Color (143, 200, 162));

		cancelBtn = new Button ("Cancel");
			cancelBtn.setBackground (new Color (255,128,128));

		addElement (EAST, l_userCode, 1, 1, 1, 1);
		addElement (WEST,     userCode,   2, 1, 0, 1);
		if (newUser == false)
		{
		addElement (EAST,      l_passwdOld,   1, 2, 1, 1);
		addElement (WEST,     oldPassword,   2, 2, 0, 1);
		}
		addElement (EAST,      l_passwd,   1, 3, 1, 1);
		addElement (WEST,     passWord,   2, 3, 0, 1);
		addElement (EAST,      l_passwd2,   1, 4, 1, 1);
		addElement (WEST,     passWord2,   2, 4, 0, 1);
		addElement (SOUTHEAST, acceptBtn,  2, 5, 1, 1);
		addElement (SOUTHEAST, cancelBtn,  4, 5, 1, 1);
		pack ();

		show ();
		userCode.requestFocus ();
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.id == Event.KEY_PRESS && evt.key == '\n')
		{
			evt.id = Event.ACTION_EVENT;
			evt.target = acceptBtn;
			evt.arg = "Accept";
			super.deliverEvent (evt);
			return (true);
		} else if (evt.id == Event.KEY_PRESS && evt.key == 0x1b)
		{
			CM.removeWindow ((GridFrame) this);
			dispose ();
		} else if ((evt.id == Event.WINDOW_DESTROY) ||
			   (evt.arg == "Cancel"))
		{
			CM.removeWindow ((GridFrame) this);
			dispose ();
		} else if (evt.arg == "Accept")
		{
			boolean doIt = true;
			if (newUser == false)
			{
				String u = userCode.getText();
				if (u.length() == 0)
				{
					new MessageBox (this, "Error", "Cannot enter blank user code");
					doIt = false;
				}
				else if (oldUser.name.equals(u) == false &&
				         theServer.userExists (u))
				{
					new MessageBox (this, "Error", "This user code is already used");
					doIt = false;
				}

			}

			if (doIt)
			{
			String enteredPassword = passWord.getText();
			String enteredConfirm = passWord2.getText();
			String enteredUser = userCode.getText();

			if (newUser)
			{
				if (enteredPassword.equals(enteredConfirm))
				{
				    User myUser = new User ();
				    myUser.name = enteredUser;
				    myUser.password = enteredPassword;
				    theServer.newUser (myUser);
				}
			}
			else
			{
				String oldEnteredPW = oldPassword.getText().trim();
				if ((oldEnteredPW.equals(oldUser.password)) &&
				    (enteredPassword.equals(enteredConfirm)))
				    {
				    	oldUser.name = enteredUser;
					oldUser.password = enteredPassword;
					theServer.updateUser (oldUser);
				    }
			}

			CM.removeWindow ((GridFrame) this);
			dispose ();
			parentList.fillUserList();
			}
		}
		return (super.handleEvent (evt));
	}
}

class UserTable extends GridFrame {

	List userList;
	Button addBtn;
	Button delBtn;
	Button modBtn;
	Button cancelBtn;
	Server theServer;
	CreateMenu CM;

	public UserTable (CreateMenu c, Server s)
	{
		super ("Valid Users");
		CM = c;
		CM.addWindow ("UserTable", (GridFrame) this);
		theServer = s;
		initScreen ();
	}

	public void initScreen ()
	{
		userList = new List (15, false);
		userList.setBackground (Color.white);
		fillUserList ();

		addBtn = new Button ("Add");
			addBtn.setBackground (new Color (145,200,162));

		modBtn = new Button ("Modify");
			modBtn.setBackground (new Color (145,196,255));

		delBtn = new Button ("Delete");
			delBtn.setBackground (new Color (255,128,128));

		cancelBtn = new Button ("Close");
			cancelBtn.setBackground (new Color (255,128,128));

		addElement (NORTHWEST, userList, 1,1,1,0);

		gridc.fill = 1;
		gridc.ipadx = gridc.ipady = 20;
		addElement (SOUTHEAST, addBtn,   2,2,1,1);
		addElement (SOUTHEAST, modBtn,   2,3,1,1);
		addElement (SOUTHEAST, delBtn,   2,4,1,1);
		addElement (SOUTHEAST, cancelBtn,2,5,1,1);

		pack();
		show();
		userList.requestFocus ();
	}

	void fillUserList ()
	{
		userList.clear ();
		for (int i =0; i < theServer.theUsers.size(); i++)
		{
			User myUser = (User) theServer.theUsers.elementAt (i);
			userList.addItem (myUser.name);
		}
	}

	public boolean handleEvent (Event evt)
	{
		if (evt.id == Event.KEY_PRESS && evt.key == '\n' && evt.target == userList)
		{
			evt.id = Event.ACTION_EVENT;
			evt.target = modBtn;
			evt.arg = "Modify";
			super.deliverEvent (evt);
			return (true);
		} else if (evt.id == Event.KEY_PRESS && evt.key == 0x1b)
		{
			CM.closeAllWindows ("UserEdit");
			CM.removeWindow ((GridFrame) this);
			dispose ();
		} else if ((evt.id == Event.WINDOW_DESTROY) ||
			   (evt.arg == "Close"))
		{
			CM.closeAllWindows ("UserEdit");
			CM.removeWindow ((GridFrame) this);
			dispose ();
		} else if ((evt.arg == "Add") || (evt.id == Event.KEY_PRESS && evt.key == 'a'))
		{
			new UserEdit (CM, theServer, this);
		} else if (evt.arg == "Modify")
		{
			int i = userList.getSelectedIndex ();
			if (i != -1)
			{
			User myUser = (User) theServer.theUsers.elementAt (i);
			new UserEdit (CM, theServer, this, myUser);
			}

		} else if ((evt.arg == "Delete") || (evt.id == Event.KEY_PRESS && evt.key == 127))
		{
			int i = userList.getSelectedIndex ();
			if (i != -1)
			{
			User myUser = (User) theServer.theUsers.elementAt (i);
			theServer.deleteUser (myUser);
			fillUserList();
			}
		}

		return (super.handleEvent (evt));
	}
}

